package com.dsic.gj_erp.service.fd.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.fd.*;
import com.dsic.gj_erp.bean.sy.SyDzbmp;
import com.dsic.gj_erp.mapper.fd.DmCzfddybMapper;
import com.dsic.gj_erp.service.fd.DmCzfddybService;
import com.dsic.gj_erp.service.fd.DmCzjbbService;
import com.dsic.gj_erp.service.fd.DmXqdwcjcdService;
import com.dsic.gj_erp.service.sy.impl.SyDzbmpService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.beans.PropertyDescriptor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xhj
 * @since 2023-05-08
 */
@Service
public class DmCzfddybServiceImpl extends ServiceImpl<DmCzfddybMapper, DmCzfddyb> implements DmCzfddybService {
    @Autowired
    DmCzjbbService czjbbService;

    @Autowired
    SyDzbmpService syDzbmpService;
  //  @Autowired
   // DmZhbmpService dmZhbmpService;
   // @Autowired
   /// MpZzdwjbbService mpZzdwjbbService;

  //  @Autowired
   // MpZzdwjbbMapper mpZzdwjbbMapper;

    @Autowired
    TpImpl tpImpl;

    @Autowired
    DmXqdwcjcdService dmXqdwcjcdService;
    

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Map uploadFd(HttpServletRequest httpRequest, List<ExcelExport> excelList, String czbh, String isupload) throws Exception {
        Map rMap = new HashMap();
         czbh=czbh+"#";
        if ("01".equals(isupload)) {
            // 查询是否 有值
            List<DmCzfddyb> czbh1 = this.list(new QueryWrapper<DmCzfddyb>().eq("czbh", czbh));
            if (czbh1.size() > 0) {
                rMap.put("zt", "01");
                return rMap;
            }
        }
        this.remove(new QueryWrapper<DmCzfddyb>().eq("CZBH", czbh));
        List<DmCzfddyb> addList = new ArrayList<>();
        int row = 0;
        for (int i = 0; i < excelList.size(); i++) {
            ExcelExport e = excelList.get(i);
            Class cls = e.getClass();
            Field[] fields = cls.getDeclaredFields();
            for (int j = 0; j < fields.length; j++) {
                String fdh = "";
                int col;
                Field f = fields[j];
                f.setAccessible(true);
                try {
                    fdh = (String) f.get(e);
                } catch (IllegalAccessException ex) {
                    throw new RuntimeException(ex);
                }
                if (StringUtils.isNotBlank(fdh)) {
                    DmCzfddyb czfddyb = new DmCzfddyb();
                    czfddyb.setCzbh(czbh);
                    czfddyb.setFdh(fdh);
                    czfddyb.setFrow(i);
                    String colName = f.getName();
                    col = Integer.parseInt(colName.substring(colName.length() - 3));
                    czfddyb.setFcol(col);
                    addList.add(czfddyb);
                }
                //System.out.println("属性名:" + f.getName() + " 属性值:" + );
            }
        }
        this.saveBatch(addList);
        return rMap;
    }

    @Override
    public Map getCzFdBase( HttpServletRequest req,Map map) {
        Map rMap = new HashMap();
        String bmbm = (String)req.getAttribute("bmbm");
        List<DmCzjbb> czbhs;
        if(StringUtils.isNotBlank(bmbm)&& bmbm.length()>2){

            czbhs = czjbbService.list(new QueryWrapper<DmCzjbb>()
                .select("replace(czbh,'#','') AS czbh")
                .in("yzbs", "N", "H").ne("isnull(czjc,'')", "")
                .ne("isnull(wgbs,'N')","Y").eq(" isnull(cims_bs,'')","Y").
                eq("left(gcqy,1)","0").
                orderBy(true, true, "wgbs", "left(czbh,charindex('-',czbh)-1)", "len(czbh)", "czbh"
                ));
        }else{
            czbhs = czjbbService.list(new QueryWrapper<DmCzjbb>()
                .select("replace(czbh,'#','') AS czbh")
                .in("yzbs", "N", "H").ne("isnull(czjc,'')", "").
                orderBy(true, true, "wgbs", "left(czbh,charindex('-',czbh)-1)", "len(czbh)", "czbh"
                ));
        }

        // 只显示海工名船    简称不等于空
        rMap.put("czbhs", czbhs);


        return rMap;
    }

    @Override
    public Map getList(Map map) throws Exception {
        Map returnMap = new HashMap();
        List<ExcelExport> returnList = new ArrayList<>();
        QueryWrapper queryWrapper = new QueryWrapper();
        queryWrapper.eq("CZBH", map.get("czbh")+"#");
        List<DmCzfddyb> list = this.list(queryWrapper);
        queryWrapper.select("max(frow) as frow ", "max(fcol)as fcol");
        DmCzfddyb one = this.getOne(queryWrapper);
        if (one != null) {
            int row = one.getFrow();
            int col = one.getFcol();
            for (int i = 0; i <= row; i++) {
                ExcelExport excelExport = new ExcelExport();
                int tempi = i;
                List<DmCzfddyb> collect = list.stream().filter(fst -> fst.getFrow() == tempi).collect(Collectors.toList());
                for (int y = 0; y <= col; y++) {
                    int tempy = y;
                    DmCzfddyb czfddyb = collect.stream().filter(fst -> fst.getFcol() == tempy).findFirst().orElse(null);
                    if (null != czfddyb) {
                        PropertyDescriptor propertyDescriptor = new PropertyDescriptor("column" + String.format("%03d", czfddyb.getFcol()), excelExport.getClass());
                        Method setMethod = propertyDescriptor.getWriteMethod();
                        // 调用指定对象set方法
                        setMethod.invoke(excelExport, czfddyb.getFdh());
                        //    System.out.println(object.getName());// 输出Jack Chen
                    }
                }
                returnList.add(excelExport);
            }
            returnMap.put("data", returnList);
            returnMap.put("col", col);
        }
        return returnMap;
    }

    @Override
    public Map getTpBase( HttpServletRequest req,Map map) throws Exception {
        Map rMap = new HashMap();
        String bmbm = (String)req.getAttribute("bmbm");
        List<DmCzjbb> czbhs;
        List<DmXqdwcjcd>cdmcs;
        List<DmXqdwcjcd>cjmcs;
        if(StringUtils.isNotBlank(bmbm)&& bmbm.length()>2){

            czbhs = czjbbService.list(new QueryWrapper<DmCzjbb>()
                .select("replace(czbh,'#','') AS czbh")
                .in("yzbs", "N", "H").ne("isnull(czjc,'')", "")
                    .ne("isnull(wgbs,'N')","Y").eq(" isnull(cims_bs,'')","Y").
                eq("left(gcqy,1)","0").
                orderBy(true, true, "wgbs", "left(czbh,charindex('-',czbh)-1)", "len(czbh)", "czbh"
                ));
            cdmcs=dmXqdwcjcdService.list(new QueryWrapper<DmXqdwcjcd>().eq("dwbm","P30000").orderBy(true,true,"cdmc"));
            cjmcs=dmXqdwcjcdService.list(new QueryWrapper<DmXqdwcjcd>().select("DISTINCT cjmc as cjmc").eq("dwbm","P30000").orderBy(true,true,"cjmc"));
        }else{
             czbhs = czjbbService.list(new QueryWrapper<DmCzjbb>()
                .select("replace(czbh,'#','') AS czbh")
                .in("yzbs", "N", "H").ne("isnull(czjc,'')", "").
                orderBy(true, true, "wgbs", "left(czbh,charindex('-',czbh)-1)", "len(czbh)", "czbh"
                ));
            cdmcs=dmXqdwcjcdService.list();
            cjmcs=dmXqdwcjcdService.list(new QueryWrapper<DmXqdwcjcd>().select("DISTINCT cjmc as cjmc"));
        }

        //作业阶段
        List<SyDzbmp> zyjds = syDzbmpService.list(new QueryWrapper<SyDzbmp>().eq("bml", "ZYJD"));
        //部件类别
       // List<DmZhbmp> bjlbs = dmZhbmpService.list(new QueryWrapper<DmZhbmp>().eq("bmlb", "TPLX"));
      //  List<Map> xqdws = mpZzdwjbbMapper.findxqdwAll();
     //   List<DmZhbmp> bmbms = dmZhbmpService.list(new QueryWrapper<DmZhbmp>().eq("bmlb", "bmbm").in("bm","01","02","03","04"));
        rMap.put("czbhs", czbhs);
        rMap.put("zyjds", zyjds);
     //   rMap.put("bjlbs", bjlbs);
       // rMap.put("xqdws", xqdws);
     //   rMap.put("bmbms", bmbms);
        rMap.put("cdmcs", cdmcs);
        rMap.put("cjmcs", cjmcs);
        return rMap;
    }

    @Override
    public Map getListFdMx(Map map) throws Exception {
//        Map returnMap = new HashMap();
        Map returnMap = this.getList(map);

        List<TppsQk> tppsQks = tpImpl.findTppsQk(map);
       // List<DmZhbmp> bjlbs = dmZhbmpService.list(new QueryWrapper<DmZhbmp>().eq("bmlb", "TPLX"));

            Map<String, List<TppsQk>> collect = tppsQks.stream().collect(
            Collectors.groupingBy(
                score -> score.getFdh()+'-'+score.getTplx()
            ));
        List<FdBean> fdBeans=new ArrayList<>();
        for(Map.Entry<String,  List<TppsQk>> entry : collect.entrySet()){
            FdBean fdBean=new FdBean();
            String mapKey = entry.getKey();
            String color="";
            String[] parts = mapKey.split("-");
            String fdh=parts[0];
            String tplx=parts[1];
//            if(a.compareTo(b) < 1){
//                System.out.println("a小于等于b");
//            }

           BigDecimal xqslSum=entry.getValue().stream().map(s-> s.getXqsl()).reduce(BigDecimal.ZERO,BigDecimal::add).setScale(2,   BigDecimal.ROUND_HALF_UP);
           BigDecimal psslSum=entry.getValue().stream().map(s-> s.getPssl()).reduce(BigDecimal.ZERO,BigDecimal::add).setScale(2,   BigDecimal.ROUND_HALF_UP);
           List<TppsQk>  rqList=entry.getValue();
           boolean flag=false;
//           if(fdh.equals("ZL04")){
//               rqList.get(0).setQfxqrq("2022/04/13");
//           }
           for(TppsQk q :rqList){
               if(StringUtils.isNotBlank(q.getQfxqrq())){
                   flag=true;
               }
           }
           if(xqslSum.compareTo(BigDecimal.ZERO)==0 ){

           }else{
               BigDecimal result =psslSum.divide(xqslSum,2,BigDecimal.ROUND_HALF_UP);
               System.out.println("result = " + result +"xqsl"+xqslSum +"pssl"+psslSum+"fhd"+fdh);

               if(result.compareTo(new BigDecimal("0.9"))> -1 ){  // result > =0.9
                   if("0201".equals(tplx)){
                       color="green";
                   }
               }else if (result.compareTo(new BigDecimal("0.5"))>-1 && result.compareTo(new BigDecimal("0.9"))<1  ) {
                   if("0201".equals(tplx)){
                       color="yellow";
                   }
               }else if( result.compareTo(new BigDecimal("0.5"))<1  && flag ){
                   if("0201".equals(tplx)){
                       color="red";
                   }
               }
               System.out.println("result = " + result +"xqsl"+xqslSum +"pssl"+psslSum+"fhd"+fdh+"COLOR"+color);
           }
            fdBean.setFdh(fdh);

                fdBean.setTplx(tplx);

                fdBean.setColor(color);

            fdBeans.add(fdBean);
        }
        returnMap.put("fd", fdBeans);
        returnMap.put("fdqk", tppsQks);
        return returnMap;
    }
}
